diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_tburst.c ircd-hybrid-fuis/modules/m_tburst.c
--- ircd-hybrid-7.0rc9/modules/m_tburst.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-fuis/modules/m_tburst.c	Wed Dec 18 00:33:29 2002
@@ -0,0 +1,162 @@
+/*  contrib/m_tburst.c
+ *  Copyright (C) 2002 Hybrid Development Team
+ *
+ *  Redistribution and use in source and binary forms, with or without
+ *  modification, are permitted provided that the following conditions are
+ *  met:
+ *
+ *  1.Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  2.Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *  3.The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ *  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ *  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ *  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
+ *  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ *  POSSIBILITY OF SUCH DAMAGE.
+ *
+ *  $Id: m_tburst.c,v 1.12 2002/12/18 05:33:29 db Exp $
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"
+#include "ircd.h"
+#include "send.h"
+#include "msg.h"
+#include "modules.h"
+#include "hook.h"
+#include "hash.h"
+#include "s_serv.h"
+#include "s_conf.h"
+
+
+/* TBURST_PROPAGATE
+ *
+ * If this is defined, when we receive a TBURST thats successful
+ * (ie: our topic changes), the TBURST will be propagated to other
+ * servers that support TBURST
+ */
+#define TBURST_PROPAGATE
+
+
+
+static void ms_tburst(struct Client *, struct Client *, int, char **);
+static void set_topic(struct Client *, struct Channel *, 
+		      time_t, char *, char *);
+static void set_tburst_capab();
+static void unset_tburst_capab();
+int send_tburst(struct hook_burst_channel *);
+
+struct Message tburst_msgtab = {
+  "TBURST", 0, 0, 6, 0, MFLG_SLOW, 0,
+  {m_ignore, m_ignore, ms_tburst, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+  mod_add_cmd(&tburst_msgtab);
+  hook_add_hook("burst_channel", (hookfn *)send_tburst);
+  set_tburst_capab();
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&tburst_msgtab);
+  hook_del_hook("burst_channel", (hookfn *)send_tburst);
+  unset_tburst_capab();
+}
+
+const char *_version = "$Revision: 1.12 $";
+#endif
+
+/* ms_tburst()
+ * 
+ *      parv[0] = sender prefix
+ *      parv[1] = channel timestamp
+ *      parv[2] = channel
+ *      parv[3] = topic timestamp
+ *      parv[4] = topic setter
+ *      parv[5] = topic
+ */
+static void ms_tburst(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  struct Channel *chptr;
+  time_t newchannelts;
+  time_t newtopicts;
+
+  newchannelts = atol(parv[1]);
+  newtopicts = atol(parv[3]);
+
+  if((chptr = hash_find_channel(parv[2])))
+  {
+    if(chptr->channelts < newchannelts)
+      return;
+
+    else if(chptr->channelts == newchannelts)
+    {
+      if(chptr->topic == NULL || (chptr->topic_time > newtopicts))
+	set_topic(source_p, chptr, newtopicts, parv[4], parv[5]);
+      else
+	return;
+    }
+
+    else
+      set_topic(source_p, chptr, newtopicts, parv[4], parv[5]);
+  }
+}
+
+static void set_topic(struct Client *source_p, struct Channel *chptr, 
+		      time_t newtopicts, char *topicwho, char *topic)
+{
+  set_channel_topic(chptr, topic, topicwho, newtopicts);
+
+  sendto_channel_local(ALL_MEMBERS, chptr, ":%s TOPIC %s :%s",
+		       ConfigServerHide.hide_servers ? me.name : me.name,
+		       chptr->chname, chptr->topic == NULL ? "" : chptr->topic);
+
+#ifdef TBURST_PROPAGATE
+  sendto_server(source_p, NULL, chptr, CAP_TBURST, NOCAPS, NOFLAGS,
+		":%s TBURST %ld %s %ld %s :%s",
+		me.name, chptr->channelts, chptr->chname,
+		chptr->topic_time, 
+                chptr->topic_info == NULL ? "" : chptr->topic_info,
+                chptr->topic == NULL ? "" : chptr->topic);
+#endif
+}
+
+static void set_tburst_capab()
+{
+  default_server_capabs |= CAP_TBURST;
+}
+
+static void unset_tburst_capab()
+{
+  default_server_capabs &= ~CAP_TBURST;
+}
+
+int send_tburst(struct hook_burst_channel *data)
+{
+  if(data->chptr->topic != NULL && IsCapable(data->client, CAP_TBURST))
+    sendto_one(data->client, ":%s TBURST %ld %s %ld %s :%s",
+               me.name, data->chptr->channelts, data->chptr->chname,
+	       data->chptr->topic_time, data->chptr->topic_info, 
+	       data->chptr->topic);
+
+  return 0;
+}
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_trace.c ircd-hybrid-fuis/modules/m_trace.c
--- ircd-hybrid-7.0rc9/modules/m_trace.c	Wed Sep  4 21:10:24 2002
+++ ircd-hybrid-fuis/modules/m_trace.c	Tue Feb 11 08:20:56 2003
@@ -58,14 +58,12 @@
 void
 _modinit(void)
 {
-  hook_add_event("doing_trace");
   mod_add_cmd(&trace_msgtab);
 }
 
 void
 _moddeinit(void)
 {
-  hook_del_event("doing_trace");
   mod_del_cmd(&trace_msgtab);
 }
 const char *_version = "$Revision: 1.51 $";
@@ -171,7 +169,7 @@
           sendto_one(source_p, form_str(RPL_TRACEOPERATOR),
                      me.name, parv[0], class_name, name, 
                      MyOper(source_p) ? ipaddr :
-		     (IsIPSpoof(target_p) ? "255.255.255.255" : ipaddr),
+					 (IsIPSpoof(target_p) ? "255.255.255.255" : ipaddr),
                      CurrentTime - target_p->lasttime,
                      (target_p->user) ? (CurrentTime - target_p->user->last) : 0);
         }
@@ -180,7 +178,7 @@
           sendto_one(source_p,form_str(RPL_TRACEUSER),
                      me.name, parv[0], class_name, name, 
                      MyOper(source_p) ? ipaddr : 
-		     (IsIPSpoof(target_p) ? "255.255.255.255" : ipaddr),
+					 (IsIPSpoof(target_p) ? "255.255.255.255" : ipaddr),
                      CurrentTime - target_p->lasttime,
                      (target_p->user)?(CurrentTime - target_p->user->last):0);
         }
@@ -365,7 +363,7 @@
           if (IsAdmin(target_p))
 	    sendto_one(source_p, form_str(RPL_TRACEOPERATOR),
                        me.name, source_p->name, class_name, name,
-                       IsOperAdmin(source_p) ? ip : "255.255.255.255",
+					   IsOperAdmin(source_p) ? ip : "255.255.255.255",
                        CurrentTime - target_p->lasttime,
                        (target_p->user) ? (CurrentTime - target_p->user->last) : 0);
 		       
@@ -375,10 +373,10 @@
 	    sendto_one(source_p, form_str(RPL_TRACEOPERATOR),
 		       me.name, source_p->name, class_name, name, 
 #ifdef HIDE_SPOOF_IPS
-		       IsIPSpoof(target_p) ? "255.255.255.255" : ip,
+              IsIPSpoof(target_p) ? "255.255.255.255" : ip,
 #else
                        MyOper(source_p) ? ip :
-		       (IsIPSpoof(target_p) ? "255.255.255.255" : ip),
+              (IsIPSpoof(target_p) ? "255.255.255.255" : ip),
 #endif
 		       CurrentTime - target_p->lasttime,
 		       (target_p->user)?(CurrentTime - target_p->user->last):0);
@@ -428,11 +426,10 @@
 static void
 trace_spy(struct Client *source_p)
 {
-  struct hook_spy_data data;
-
-  data.source_p = source_p;
-
-  hook_call_event("doing_trace", &data);
+  sendto_realops_flags(FLAGS_SPY, L_ALL,
+           "trace requested by %s (%s@%s) [%s]",
+           source_p->name, source_p->username,
+           source_p->host, source_p->user->server);
 }
 
 /* 
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_unkline.c ircd-hybrid-fuis/modules/m_unkline.c
--- ircd-hybrid-7.0rc9/modules/m_unkline.c	Mon Nov 18 14:54:58 2002
+++ ircd-hybrid-fuis/modules/m_unkline.c	Sun Feb 16 21:09:37 2003
@@ -39,22 +39,18 @@
 #include "s_misc.h"
 #include "send.h"
 #include "msg.h"
-#include "s_gline.h"
 #include "parse.h"
 #include "modules.h"
 
 
 static void mo_unkline(struct Client*, struct Client*, int, char**);
 static void mo_undline(struct Client*, struct Client*, int, char**);
-static void mo_ungline(struct Client*, struct Client*, int, char**);
 
 struct Message msgtabs[] = {
   {"UNKLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
    {m_unregistered, m_not_oper, m_error, mo_unkline}},
   {"UNDLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
-   {m_unregistered, m_not_oper, m_error, mo_undline}}, 
-  {"UNGLINE", 0, 0, 2, 0, MFLG_SLOW, 0,
-   {m_unregistered, m_not_oper, m_error, mo_ungline}}
+   {m_unregistered, m_not_oper, m_error, mo_undline}}
 };
 
 #ifndef STATIC_MODULES
@@ -424,74 +420,3 @@
   ilog(L_NOTICE, "%s removed D-Line for [%s]", get_oper_name(source_p),
        cidr);
 }
-
-/*
-** m_ungline
-** added May 29th 2000 by Toby Verrall <toot@melnet.co.uk>
-** added to hybrid-7 7/11/2000 --is
-**
-**      parv[0] = sender nick
-**      parv[1] = gline to remove
-*/
-
-static void
-mo_ungline(struct Client *client_p, struct Client *source_p,
-	   int parc,char *parv[])
-{
-  char  *user,*host;
-
-  if (!ConfigFileEntry.glines)
-    {
-      sendto_one(source_p,":%s NOTICE %s :UNGLINE disabled",me.name,parv[0]);
-      return;
-    }
-
-  if (!IsOperUnkline(source_p) || !IsOperGline(source_p))
-    {
-      sendto_one(source_p,":%s NOTICE %s :You need unkline = yes;",
-                 me.name,parv[0]);
-      return;
-    }
-
-  if ((host = strchr(parv[1], '@')) || *parv[1] == '*')
-    {
-      /* Explicit user@host mask given */
-
-      if(host != NULL)                  /* Found user@host */
-        {
-          user = parv[1];       /* here is user part */
-          *(host++) = '\0';     /* and now here is host */
-        }
-      else
-        {
-          user = "*";           /* no @ found, assume its *@somehost */
-          host = parv[1];
-        }
-    }
-  else
-    {
-      sendto_one(source_p, ":%s NOTICE %s :Invalid parameters",
-                 me.name, parv[0]);
-      return;
-    }
-
-  if(remove_gline_match(user, host))
-    {
-      sendto_one(source_p, ":%s NOTICE %s :G-Line for [%s@%s] is removed",
-                 me.name, parv[0], user, host);
-      sendto_realops_flags(FLAGS_ALL, L_ALL,
-			   "%s has removed the G-Line for: [%s@%s]",
-			   get_oper_name(source_p), user, host );
-      ilog(L_NOTICE, "%s removed G-Line for [%s@%s]",
-          get_oper_name(source_p), user, host);
-      return;
-    }
-  else
-    {
-      sendto_one(source_p, ":%s NOTICE %s :No G-Line for %s@%s",
-                 me.name, parv[0],user,host);
-      return;
-    }
-}
-
-
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_userhost.c ircd-hybrid-fuis/modules/m_userhost.c
--- ircd-hybrid-7.0rc9/modules/m_userhost.c	Fri May 24 19:34:23 2002
+++ ircd-hybrid-fuis/modules/m_userhost.c	Sun Feb  9 08:21:20 2003
@@ -76,6 +76,9 @@
   int cur_len;
   int rl;
 
+  if (client_p->user)
+    client_p->user->known = 1;
+
   cur_len = ircsprintf(buf,form_str(RPL_USERHOST),me.name, parv[0], "");
   t = buf + cur_len;
 
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_users.c ircd-hybrid-fuis/modules/m_users.c
--- ircd-hybrid-7.0rc9/modules/m_users.c	Fri May 24 19:34:23 2002
+++ ircd-hybrid-fuis/modules/m_users.c	Sun Feb  9 08:21:20 2003
@@ -78,6 +78,9 @@
 
   sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, parv[0],
                  Count.total, Count.max_tot);
+				 
+  sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, parv[0],
+                 CurrentIdentUsers, MaxIdentUsers);
 }
 
 /*
@@ -99,6 +102,9 @@
 
       sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, parv[0],
                  Count.total, Count.max_tot);
+				 
+      sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, parv[0],
+                 CurrentIdentUsers, MaxIdentUsers);
     }
 }
 
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_version.c ircd-hybrid-fuis/modules/m_version.c
--- ircd-hybrid-7.0rc9/modules/m_version.c	Wed Jul 17 19:09:10 2002
+++ ircd-hybrid-fuis/modules/m_version.c	Sun Feb 16 21:09:37 2003
@@ -157,10 +157,6 @@
   if(ConfigChannel.use_except)
     *p++ = 'e';
     
-  if (ConfigFileEntry.glines)
-    *p++ = 'g';
-    *p++ = 'G';
-
   /* might wanna hide this :P */
   if (ServerInfo.hub && 
       (!ConfigServerHide.disable_remote || IsOper(source_p)) )
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_wallops.c ircd-hybrid-fuis/modules/m_wallops.c
--- ircd-hybrid-7.0rc9/modules/m_wallops.c	Thu Jan  9 01:20:07 2003
+++ ircd-hybrid-fuis/modules/m_wallops.c	Sat Feb 22 16:44:15 2003
@@ -77,6 +77,12 @@
       return;
     }
 
+  if (MyClient(source_p) && !IsOperOperwall(source_p))
+  {
+    sendto_one(source_p, "YYyy, haven't I told you, that you don't have rights to do this?!");
+    return;
+  }
+  
   sendto_wallops_flags(FLAGS_OPERWALL, source_p, "OPERWALL - %s", message);
   sendto_server(NULL, source_p, NULL, NOCAPS, NOCAPS, LL_ICLIENT,
                 ":%s WALLOPS :%s", parv[0], message);
@@ -100,6 +106,12 @@
                  me.name, parv[0], "WALLOPS");
       return;
     }
+
+  if (MyClient(source_p) && !IsOperOperwall(source_p))
+  {
+    sendto_one(source_p, "YYyy, haven't I told you, that you don't have rights to do this?!");
+    return;
+  }
 
   if(IsClient(source_p))
     sendto_wallops_flags(FLAGS_OPERWALL, source_p, "OPERWALL - %s", message);
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_who.c ircd-hybrid-fuis/modules/m_who.c
--- ircd-hybrid-7.0rc9/modules/m_who.c	Thu Jan 16 18:54:02 2003
+++ ircd-hybrid-fuis/modules/m_who.c	Sat Mar 22 18:55:33 2003
@@ -112,8 +112,10 @@
   struct Channel *vchan;
 #endif
 
-  /* See if mask is there, collapse it or return if not there */
+/*  if (client_p->user)
+    client_p->user->known = 1;*/
 
+  /* See if mask is there, collapse it or return if not there */
   if (mask != NULL)
     {
       (void)collapse(mask);
@@ -371,7 +373,7 @@
     if (!IsPerson(target_p))
       continue;
 
-    if (IsInvisible(target_p))
+    if (IsInvisible(target_p) && !IsOper(source_p))
     {
       ClearMark(target_p);
       continue;
@@ -456,9 +458,10 @@
 {
 #ifndef ANONOPS
   dlink_node *ptr;
+#else
+  int done=0;
 #endif
   struct Client *target_p;
-  int done=0;
   int i=0;
   
   if(peons_list != NULL)
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/modules/m_whois.c ircd-hybrid-fuis/modules/m_whois.c
--- ircd-hybrid-7.0rc9/modules/m_whois.c	Sat Feb  8 19:02:28 2003
+++ ircd-hybrid-fuis/modules/m_whois.c	Wed Mar 12 16:24:46 2003
@@ -44,6 +44,7 @@
 #include "parse.h"
 #include "modules.h"
 #include "hook.h"
+#include "resv.h"
 
 static int do_whois(struct Client *client_p, struct Client *source_p,
                     int parc, char *parv[]);
@@ -51,7 +52,7 @@
                         int wilds, int glob);
 static void whois_person(struct Client *source_p,struct Client *target_p,int glob);
 static int global_whois(struct Client *source_p, char *nick, int wilds, int glob);
-
+static char *get_random_reason ();
 static void m_whois(struct Client*, struct Client*, int, char**);
 static void ms_whois(struct Client*, struct Client*, int, char**);
 static void mo_whois(struct Client*, struct Client*, int, char**);
@@ -65,14 +66,12 @@
 void
 _modinit(void)
 {
-  hook_add_event("doing_whois");
   mod_add_cmd(&whois_msgtab);
 }
 
 void
 _moddeinit(void)
 {
-  hook_del_event("doing_whois");
   mod_del_cmd(&whois_msgtab);
 }
 
@@ -381,7 +380,7 @@
   char *t;
   int tlen;
   int reply_to_send = NO;
-  struct hook_mfunc_data hd;
+  struct ResvNick *resv;
 #ifdef VCHANS
   struct Channel *bchan;
 #endif
@@ -393,54 +392,68 @@
 	 target_p->username, target_p->host, target_p->info);
   server_name = (char *)target_p->user->server;
 
-  ircsprintf(buf, form_str(RPL_WHOISCHANNELS),
-	       me.name, source_p->name, target_p->name, "");
+  if (IsOper(source_p) || (target_p == source_p))
+      sendto_one(source_p, form_str(RPL_WHOISREALHOST), me.name,
+      source_p->name, target_p->name,
+      ServerInfo.network_name, target_p->realhost);
 
-  mlen = strlen(buf);
-  cur_len = mlen;
-  t = buf + mlen;
+  if ((resv = return_nick_resv(target_p->name)) && !irccmp(resv->reason, 
+ConfigFileEntry.services_qline)) {
+          sendto_one(source_p, form_str(RPL_SERVICESCHANS),
+                                 me.name, source_p->name, target_p->name);
+} else if(HasNoChannelList(target_p) && !IsOper(source_p) && (target_p != source_p)) {
+	  sendto_one(source_p, form_str(RPL_NOLIST),
+  				 me.name, source_p->name, target_p->name);
+}
+  else {
+	ircsprintf(buf, form_str(RPL_WHOISCHANNELS),
+	    	   me.name, source_p->name, target_p->name, "");
+    mlen = strlen(buf);
+	cur_len = mlen;
+    t = buf + mlen;
 
-  DLINK_FOREACH(lp, target_p->user->channel.head)
-  {
-    chptr = lp->data;
-    chname = chptr->chname;
+	DLINK_FOREACH(lp, target_p->user->channel.head)
+    {
+	  chptr = lp->data;
+      chname = chptr->chname;
 
 #ifdef VCHANS
-    if (IsVchan(chptr))
-    {
-      bchan = find_bchan (chptr);
-      if (bchan != NULL)
-	chname = bchan->chname;
-    }
+	  if (IsVchan(chptr))
+  	  {
+    	bchan = find_bchan (chptr);
+    	if (bchan != NULL)
+		  chname = bchan->chname;
+  	  }
 #endif
 
-    if (ShowChannel(source_p, chptr))
-    {
-      if ((cur_len + strlen(chname) + 2) > (BUFSIZE - 4))
-      {
-	sendto_one(source_p, "%s", buf);
-	cur_len = mlen;
-	t = buf + mlen;
-      }
+  	  if (ShowChannel(source_p, chptr) || IsOper(source_p))
+  	  {
+  	    if ((cur_len + strlen(chname) + 2) > (BUFSIZE - 4))
+    	{
+		  sendto_one(source_p, "%s", buf);
+		  cur_len = mlen;
+		  t = buf + mlen;
+	    }
 
-      if (chptr->mode.mode & MODE_HIDEOPS && !is_any_op(chptr,source_p))
-      {
-	ircsprintf(t,"%s ",chname);
-      }
-      else
-      {
-	ircsprintf(t,"%s%s ", channel_chanop_or_voice(chptr,target_p), chname);
-      }
+        if (chptr->mode.mode & MODE_HIDEOPS && !is_any_op(chptr,source_p) && !IsOper(source_p))
+	    {
+		  ircsprintf(t,"%s ",chname);
+        }
+	    else
+        {
+		  ircsprintf(t,"%s%s ", channel_chanop_or_voice(chptr,target_p), chname);
+    	}
 
-      tlen = strlen(t);
-      t += tlen;
-      cur_len += tlen;
-      reply_to_send = YES;
-    }
-  }
+    	tlen = strlen(t);
+    	t += tlen;
+    	cur_len += tlen;
+    	reply_to_send = YES;
+  	  }
+	}
 
-  if (reply_to_send)
-    sendto_one(source_p, "%s", buf);
+	if (reply_to_send)
+	  sendto_one(source_p, "%s", buf);
+  }
           
   if ((IsOper(source_p) || !ConfigServerHide.hide_servers) || target_p == source_p)
     sendto_one(source_p, form_str(RPL_WHOISSERVER),
@@ -456,16 +469,34 @@
     sendto_one(source_p, form_str(RPL_AWAY), me.name,
 	       source_p->name, target_p->name, target_p->user->away);
 
-  if (IsOper(target_p))
+  if (IsOper(target_p) && MyClient(source_p))
     sendto_one(source_p, form_str(RPL_WHOISOPERATOR),
-	       me.name, source_p->name, target_p->name);
+	       me.name, source_p->name, target_p->name, get_random_reason());
+
+  if (IsNSId(target_p))
+   sendto_one(source_p, form_str(RPL_NS_ID),
+     me.name, source_p->name, target_p->name);
+
+  if ((target_p->umodes & FLAGS_AVFH))
+   sendto_one(source_p, form_str(RPL_AVFH),
+     me.name, source_p->name, target_p->name);
+
+  if (IsOSId(target_p))
+   sendto_one(source_p, form_str(RPL_OS_ID),
+     me.name, source_p->name, target_p->name);
+
+  if (IsNetKeeper(target_p))
+   sendto_one(source_p, form_str(RPL_NK_ID),
+     me.name, source_p->name, target_p->name);
+
+  if (HasSilence(target_p))
+   sendto_one(source_p, form_str(RPL_SILENCE),
+     me.name, source_p->name, target_p->name);
 
   if (MyConnect(target_p)) /* Can't do any of this if not local! db */
   {
-    if ( (glob) ||
-         ( MyClient(source_p) && (IsOper(source_p) ||
-                                  !ConfigServerHide.hide_servers) ) ||
-         (source_p == target_p) )
+    if (((glob) || (MyClient(source_p) && (IsOper(source_p) || !ConfigServerHide.hide_servers)) ||
+         (source_p == target_p)) && (!(target_p->umodes & FLAGS_NOIDLE) || IsOper(source_p)))
     {
       sendto_one(source_p, form_str(RPL_WHOISIDLE),
 	         me.name, source_p->name, target_p->name,
@@ -474,14 +505,16 @@
     }
   }
 
-  hd.client_p = target_p;
-  hd.source_p = source_p;
-
 /* although we should fill in parc and parv, we don't ..
  *	 be careful of this when writing whois hooks
  */
-  if(MyClient(source_p)) 
-    hook_call_event("doing_whois", &hd);
+  if (MyClient(source_p) && IsOper(target_p) && target_p != source_p && (target_p->umodes & FLAGS_SPY))
+	sendto_one(target_p, ":%s NOTICE %s :*** Notice -- %s (%s@%s) is doing a whois on you",
+			   me.name,
+			   target_p->name,
+			   source_p->name,
+			   source_p->username,
+			   source_p->host);
   
   return;
 }
@@ -617,3 +650,20 @@
   do_whois(client_p, source_p, parc, parv);
   return;
 }
+
+static char *get_random_reason()
+{
+  int i, desired;
+  MessageFileLine *linenode = ConfigFileEntry.fopers.contentsOfFile;
+
+  if (linenode == NULL)
+    return "Is an IRC Operator";
+
+  desired = random() % ConfigFileEntry.fopers.linecount;
+
+  for (i = 0; i < desired; i++)
+    linenode = linenode->next;
+
+  return linenode->line;
+}
+
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/.depend ircd-hybrid-fuis/src/.depend
--- ircd-hybrid-7.0rc9/src/.depend	Thu Jan 30 05:28:45 2003
+++ ircd-hybrid-fuis/src/.depend	Wed Mar 12 16:47:08 2003
@@ -61,7 +61,7 @@
   ../include/memory.h ../include/balloc.h ../include/irc_string.h \
   ../include/sprintf_irc.h ../include/class.h ../include/channel_mode.h \
   ../include/common.h ../include/event.h ../include/fdlist.h \
-  ../include/hash.h ../include/list.h ../include/s_gline.h \
+  ../include/hash.h ../include/list.h \
   ../include/numeric.h ../include/packet.h ../include/s_auth.h \
   ../include/s_bsd.h ../include/s_conf.h ../include/motd.h \
   ../include/s_log.h ../include/s_misc.h ../include/s_serv.h \
@@ -138,7 +138,7 @@
   ../include/irc_string.h ../include/sprintf_irc.h ../include/common.h \
   ../include/event.h ../include/fdlist.h ../include/hash.h \
   ../include/ircdauth.h ../include/ircd_signal.h ../include/list.h \
-  ../include/s_gline.h ../include/motd.h ../include/md5.h \
+  ../include/motd.h ../include/md5.h \
   ../include/msg.h ../include/hostmask.h ../include/numeric.h \
   ../include/parse.h ../include/restart.h ../include/s_auth.h \
   ../include/s_bsd.h ../include/s_conf.h ../include/s_debug.h \
@@ -344,7 +344,7 @@
   ../include/list.h ../include/listener.h ../include/hostmask.h \
   ../include/modules.h ../include/parse.h ../include/msg.h \
   ../include/numeric.h ../include/fdlist.h ../include/s_bsd.h \
-  ../include/s_log.h ../include/send.h ../include/s_gline.h \
+  ../include/s_log.h ../include/send.h \
   ../include/s_debug.h
 s_debug.o: s_debug.c ../include/stdinc.h ../include/config.h \
   ../include/setup.h ../include/defaults.h ../include/tools.h \
@@ -357,19 +357,6 @@
   ../include/list.h ../include/numeric.h ../include/s_conf.h \
   ../include/motd.h ../include/s_log.h ../include/scache.h \
   ../include/send.h ../include/whowas.h
-s_gline.o: s_gline.c ../include/stdinc.h ../include/config.h \
-  ../include/setup.h ../include/defaults.h ../include/tools.h \
-  ../include/handlers.h ../include/channel.h ../include/ircd_defs.h \
-  ../include/client.h ../include/ircd_handler.h ../include/linebuf.h \
-  ../include/res.h ../include/fileio.h ../adns/adns.h ../include/ircd.h \
-  ../include/memory.h ../include/balloc.h ../include/irc_string.h \
-  ../include/sprintf_irc.h ../include/common.h ../include/m_kline.h \
-  ../include/hostmask.h ../include/numeric.h ../include/fdlist.h \
-  ../include/s_bsd.h ../include/s_conf.h ../include/motd.h \
-  ../include/class.h ../include/s_misc.h ../include/scache.h \
-  ../include/send.h ../include/msg.h ../include/s_serv.h \
-  ../include/s_gline.h ../include/hash.h ../include/event.h \
-  ../include/list.h
 s_log.o: s_log.c ../include/stdinc.h ../include/config.h \
   ../include/setup.h ../include/defaults.h ../include/client.h \
   ../include/ircd_defs.h ../include/ircd_handler.h ../include/linebuf.h \
